<html>
<head>
<title>CPI viewer | Written by Evgeny Stepanischev</title>
<style type="text/css">
	select,
	input		{ font-family: Tahoma; font-size: 10px; border: 5 solid gray;}
	body, td	{ font-family: Tahoma; font-size: 12px }
</style>
</head>
<?
	if (isset($_GET) && isset($_GET['file'])) $file = $_GET['file'];
?>
<body bgcolor="black" text="white" alink="white" vlink="white" link="white" scroll="auto">
<b><a href="index.php">&lt;&lt; Test screen</a></b>
<br /><br />
<form method="get">
<select name="file">
<option value="" />Choose...
<option />
<?
	$d = dir ('./cpi');
	while (($f = $d->read()) !== false)
	if (substr($f, -4) == '.cpi')
	echo "<option ", (isset($file) && $f == $file ? 'selected' : ''), "/>$f\n";

	$d->close();
?>
</select>
<br /><br />
<input type="submit" value=" Now show me tits! " /><br /><br />
<?

	function My_MapFile(&$fp, $headers, $types)
	{
		$result = array();

		for ($i = 0; $i<count($headers); $i++)
		{
			echo ($headers[$i] == '' ? 'RESERVED' : $headers[$i]), ': ';
			$str = fread ($fp, $num = (int) substr($types[$i], 1));

			switch ($types[$i][0])
			{
				case 't': $result[$i] = My_B2 ($str); break;
				case 'n': $result[$i] = ord ($str[0]); break;

				case 's':
				case 'i': $result[$i] = join ('', unpack ($num == 2 ? 'S' : 'L', $str));
						  if ($types[$i][0] == 'i') break;

						  $values = array_slice(explode ('|', substr($types[$i], 1)), 1);

						  if (count($values) <= $result[$i] || $values[$result[$i]] == '?')
						  $result[$i] = "unknown ({$result[$i]})"; else
						  $result[$i] = $values[$result[$i]];
						  break;

				default:  $result[$i] = "<font color=\"red\">invalid type ({$types[$i][0]})</font>";
			}

			echo "{$result[$i]}<br />";
		}
		return $result;
	}

	function My_B2 ($str)
	{
		for ($i = 0 or $out = ''; $i<strlen($str); $i++)
		$out.= ($ch = ord($str[$i])) > 31 ? htmlspecialchars($str[$i]) : "\{#$ch}";
		return '"'.$out.'"';
	}

	function ReadFontHeader(&$fp)
	{
		$h = array ('Rows in character box', 'Columns in char. box', 'NOT USED', 'No. of chacters in font');
		$t = array ('n1', 'n1', 't2', 'i2');
		$ret = My_MapFile ($fp, $h, $t);

		return $ret[0] * $ret[3];
	}

	function ReadPrinterHeader(&$fp)
	{
		$h = array ('Printer selection type', 'Total no. of bytes in control sequence');
		$t = array ('s2|?|4201|5202/4208', 'i2');
		$ret = My_MapFile ($fp, $h, $t);

		return 0;
	}

if (isset($file) && $file <> '')
{
	$fp = fopen ('cpi/'.$file, 'rb');
	$h = array ('Header', '', 'No. of pointer in header', 'Type of pointer', 'Offset to info from start of file', 'No. of entries');
	$t = array ('t8', 't8', 'i2', 'n1', 'i4', 'i2');
	$res = My_MapFile ($fp, $h, $t);
	echo '<br />';

	$add_offset = $res[0] == "\xFFFONT.NT" ? 25 : 0;

	for ($i = 0; $i < $res[5]; $i++)
	{
		echo "<b> <font color=\"lime\">Code page section No. ",$i+1,"</font></b><br /><br />";

		$h = array ('Size of code', 'Pointer to next entry', 'Device type', 'Device name (ID)', 'Code page ID',
		'', 'Pointer to font info', '', 'No. of fonts', 'Length of font data');
		$t = array ('i2', 'i4', 's2|?|display|printer', 't8', 'i2', 't6', 'i4', 't2', 'i2', 'i2');
		$ret = My_MapFile ($fp, $h, $t);

		echo "<br />";

		for ($j = 0; $j < $ret[8]; $j++)
		{
			if ($ret[2] == 'display')
            {
				echo "<font color=\"yellow\"> <b>Font section No. ", $j+1, '</b></font><br /><br />';
				$skip = ReadFontHeader($fp);
			} else
			$skip = ReadPrinterHeader($fp);;

			if (!$skip) break;
			fseek ($fp, $skip, SEEK_CUR);
			echo "<br />";
		}

		fseek ($fp, $ret[1] + $add_offset, 0);
		echo "<hr noshade=\"yes\" />";
	};

} else
{
	echo 'No file was selected.';
}
?>

</form>
</body>
</html>